<?php







namespace Inc;

final class Init{

    /**
     * Store all the classes inside an array
     * @return array Full list of classes
     */
    public static function get_services(){
        return [
            Pages\AdminOptionsPage::class,
            Pages\AdminWcTable::class,
            Base\Enqueue::class,
            Base\AjaxCalls::class
        ];
    }

    /**
     * Lopp through the classes, initialize them
     * and call the register() method if it exists.
     * @return 
     */
    public static function register_services() {

        foreach( self::get_services() as $class ){

            $service = self::instantiate( $class );
            if( method_exists($service, 'register') ){
                $service->register();
            }

        }

    }

    /**
     * Initialize the class
     * @param class $class class fro mthe services array
     * @return class instance new instance of the class
     */
    private static function instantiate( $class )
    {
        $service = new $class();

        return $service;
    }



}










